Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.IO

Public Class fmMain
    Inherits System.Windows.Forms.Form

    'HANDLE CreateFile(
    '  LPCTSTR lpFileName,
    '  DWORD dwDesiredAccess,
    '  DWORD dwShareMode,
    '  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
    '  DWORD dwCreationDisposition,
    '  DWORD dwFlagsAndAttributes,
    '  HANDLE hTemplateFile
    ');
    Declare Auto Function CreateFile Lib "kernel32" ( _
       ByVal lpFileName As String, _
       ByVal dwDesiredAccess As Integer, _
       ByVal dwShareMode As Integer, _
       ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, _
       ByVal dwCreationDisposition As Integer, _
       ByVal dwFlagsAndAttributes As Integer, _
       ByVal hTemplateFile As IntPtr) As IntPtr

    'BOOL CloseHandle(
    '  HANDLE hObject
    ');
    Declare Function CloseHandle Lib "kernel32" ( _
       ByVal hObject As IntPtr) As Boolean

    'typedef struct _SECURITY_ATTRIBUTES {
    '  DWORD nLength;
    '  LPVOID lpSecurityDescriptor;
    '  BOOL bInheritHandle;
    '} SECURITY_ATTRIBUTES, *PSECURITY_ATTRIBUTES;
    Structure SECURITY_ATTRIBUTES
        Dim nLength As Integer
        Dim lpSecurityDescriptor As Integer
        Dim bInheritHandle As Integer
    End Structure

    Const GENERIC_READ As Integer = &H80000000
    Const FILE_SHARE_READ As Integer = &H1
    Const OPEN_EXISTING As Integer = &H3
    Const INVALID_HANDLE_VALUE As Integer = -1
    Const FILE_FLAG_BACKUP_SEMANTICS As Integer = &H2000000

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents FolderBrowserDialog1 As System.Windows.Forms.FolderBrowserDialog
    Friend WithEvents SaveFileDialog1 As System.Windows.Forms.SaveFileDialog
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Button3 As System.Windows.Forms.Button
    Friend WithEvents Button4 As System.Windows.Forms.Button
    Friend WithEvents tb_StartingDir As System.Windows.Forms.TextBox
    Friend WithEvents tb_logfile As System.Windows.Forms.TextBox
    Friend WithEvents lb_Status As System.Windows.Forms.Label
    Friend WithEvents Button5 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(fmMain))
        Me.tb_StartingDir = New System.Windows.Forms.TextBox
        Me.tb_logfile = New System.Windows.Forms.TextBox
        Me.FolderBrowserDialog1 = New System.Windows.Forms.FolderBrowserDialog
        Me.SaveFileDialog1 = New System.Windows.Forms.SaveFileDialog
        Me.Button1 = New System.Windows.Forms.Button
        Me.Button2 = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Button3 = New System.Windows.Forms.Button
        Me.Button4 = New System.Windows.Forms.Button
        Me.lb_Status = New System.Windows.Forms.Label
        Me.Button5 = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'tb_StartingDir
        '
        Me.tb_StartingDir.Location = New System.Drawing.Point(120, 40)
        Me.tb_StartingDir.Name = "tb_StartingDir"
        Me.tb_StartingDir.Size = New System.Drawing.Size(384, 20)
        Me.tb_StartingDir.TabIndex = 0
        Me.tb_StartingDir.Text = "d:\"
        '
        'tb_logfile
        '
        Me.tb_logfile.Location = New System.Drawing.Point(120, 80)
        Me.tb_logfile.Name = "tb_logfile"
        Me.tb_logfile.Size = New System.Drawing.Size(384, 20)
        Me.tb_logfile.TabIndex = 1
        Me.tb_logfile.Text = "c:\temp\CopyFail.txt"
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(512, 40)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(24, 24)
        Me.Button1.TabIndex = 2
        Me.Button1.Text = "..."
        '
        'Button2
        '
        Me.Button2.Location = New System.Drawing.Point(512, 80)
        Me.Button2.Name = "Button2"
        Me.Button2.Size = New System.Drawing.Size(24, 24)
        Me.Button2.TabIndex = 3
        Me.Button2.Text = "..."
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(24, 32)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(88, 32)
        Me.Label1.TabIndex = 4
        Me.Label1.Text = "Starting Directory:"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 72)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(88, 32)
        Me.Label2.TabIndex = 5
        Me.Label2.Text = "Logfile:"
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight
        '
        'Button3
        '
        Me.Button3.Location = New System.Drawing.Point(136, 200)
        Me.Button3.Name = "Button3"
        Me.Button3.Size = New System.Drawing.Size(72, 48)
        Me.Button3.TabIndex = 6
        Me.Button3.Text = "Doit"
        '
        'Button4
        '
        Me.Button4.Location = New System.Drawing.Point(344, 200)
        Me.Button4.Name = "Button4"
        Me.Button4.Size = New System.Drawing.Size(72, 48)
        Me.Button4.TabIndex = 7
        Me.Button4.Text = "Quit"
        '
        'lb_Status
        '
        Me.lb_Status.Location = New System.Drawing.Point(16, 136)
        Me.lb_Status.Name = "lb_Status"
        Me.lb_Status.Size = New System.Drawing.Size(512, 40)
        Me.lb_Status.TabIndex = 8
        Me.lb_Status.Text = "Ready..."
        '
        'Button5
        '
        Me.Button5.Location = New System.Drawing.Point(240, 200)
        Me.Button5.Name = "Button5"
        Me.Button5.Size = New System.Drawing.Size(72, 48)
        Me.Button5.TabIndex = 9
        Me.Button5.Text = "View Log"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(544, 266)
        Me.Controls.Add(Me.Button5)
        Me.Controls.Add(Me.lb_Status)
        Me.Controls.Add(Me.Button4)
        Me.Controls.Add(Me.Button3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.Button2)
        Me.Controls.Add(Me.Button1)
        Me.Controls.Add(Me.tb_logfile)
        Me.Controls.Add(Me.tb_StartingDir)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.Text = "Copy Fail"
        Me.ResumeLayout(False)

    End Sub

#End Region
    Private sw As StreamWriter
    Private dirs, files, failures As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FolderBrowserDialog1.RootFolder = Environment.SpecialFolder.MyComputer
        FolderBrowserDialog1.ShowDialog()
        tb_StartingDir.Text = FolderBrowserDialog1.SelectedPath
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        SaveFileDialog1.AddExtension = True
        SaveFileDialog1.FileName = tb_logfile.Text
        SaveFileDialog1.DefaultExt = "txt"
        SaveFileDialog1.Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
        SaveFileDialog1.InitialDirectory = tb_logfile.Text
        SaveFileDialog1.CheckFileExists = False
        SaveFileDialog1.OverwritePrompt = True
        SaveFileDialog1.ShowDialog()
        tb_logfile.Text = SaveFileDialog1.FileName
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim fs As FileStream

        ' create a logfile
        Try
            fs = New FileStream(tb_logfile.Text, FileMode.Create)
            sw = New StreamWriter(fs)
        Catch ex As Exception
            MsgBox("Can't open log file" & vbCr & ex.Message, MsgBoxStyle.Exclamation, "Error!")
            Exit Sub
        End Try

        ' do it...
        sw.WriteLine("Started: " & Now)
        Dim tick As Long
        tick = Environment.TickCount
        Traverse(tb_StartingDir.Text)

        ' clean up and go home
        sw.WriteLine("Finished: " & Now)
        sw.Close()
        fs.Close()
        MsgBox("Scanned " & dirs & " directories and " & files & " files" & vbCr & "and found " & failures & " failures" & vbCr & "in " & (Environment.TickCount - tick) / 60000.0 & " minutes")
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.Close()
    End Sub

    Private Sub Traverse(ByVal p As String)
        Dim fi As FileInfo
        Dim d, di As DirectoryInfo
        Dim h As IntPtr
        Dim LastError As Integer
        Dim Win32Error As Win32Exception
        'Dim fs As FileStream

        ' skip the recycle bin and other directories we don't want...
        If p.Substring(1).Equals(":\RECYCLER") Or p.Substring(1).Equals(":\System Volume Information") Then
            Exit Sub
        End If

        ' dress it up a wee bit...
        If Not p.EndsWith("\") Then
            p = p & "\"
        End If

        ' keep 'em entertained...
        lb_Status.Text = p
        Application.DoEvents()

        Try
            di = New DirectoryInfo(p)
        Catch ex As Exception
            sw.WriteLine(ex.Message)
            failures += 1
            Exit Sub
        End Try

        Try
            For Each fi In di.GetFiles
                Try
                    'fs = fi.Open(FileMode.Open, FileAccess.Read)
                    h = CreateFile(fi.FullName, GENERIC_READ, FILE_SHARE_READ, Nothing, OPEN_EXISTING, 0, Nothing)

                    If h.ToInt32 = INVALID_HANDLE_VALUE Then
                        LastError = Marshal.GetLastWin32Error()
                        Win32Error = New Win32Exception(LastError)
                        sw.WriteLine(fi.FullName & ": " & Win32Error.Message)
                        failures += 1
                    Else
                        CloseHandle(h)
                    End If
                Catch ex As Exception
                    sw.WriteLine(ex.Message)
                    failures += 1
                End Try
                'If Not IsNothing(fs) Then
                '    fs.Close()
                'End If
                files += 1
            Next
        Catch ex As Exception
            sw.WriteLine(ex.Message)
            failures += 1
            Exit Sub
        End Try

        ' Process the directories (and descend into dir structure)
        For Each d In di.GetDirectories
            dirs += 1

            ' a recursive call to this subroutine
            Traverse(d.FullName)
        Next
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If [File].Exists(tb_logfile.Text) Then
            Shell("notepad.exe " & tb_logfile.Text, AppWinStyle.NormalFocus)
        End If
    End Sub
End Class
